
import processing.serial.*;

Serial myPort;        // The serial port
int xPos = 1;         // horizontal position of the graph 

//Variables to draw a continuous line.
int lastxPos=1;
int lastheight=0;
color currentcolor;
RectButton rect1, rect2, rect3, rect4, rect5;
boolean locked = false;
void setup () {
  // set the window size:
  size(1280, 700);        

  // List all the available serial ports
  println(Serial.list());
  // Check the listed serial ports in your machine
  // and use the correct index number in Serial.list()[].

myPort = new Serial(this, "/dev/tty.HC-05-DevB", 9600); 

  // A serialEvent() is generated when a newline character is received :
  myPort.bufferUntil('\n');
  background(0);      // set inital background:
  int x = 30;
  int y = height/4;
  int size = 50;
  color buttoncolor = color(153, 0, 0);
  color highlight = color(255, 0, 0); 
  rect1 = new RectButton(x, y, size, buttoncolor, highlight);
  // Define and create rectangle button #2
  x = 90;
  y = height/4; 
  size = 50;
  buttoncolor = color(0, 153, 0);
  highlight = color(0, 255, 0); 
  rect2 = new RectButton(x, y, size, buttoncolor, highlight);
  // Define and create rectangle button #3

  x = 150;
  y = height/4; 
  size = 50;
  buttoncolor = color(0, 0, 153);
  highlight = color(0, 0, 255);
rect3 = new RectButton(x, y, size, buttoncolor, highlight);
  // Define and create rectangle button #4
x = 210;
  y = height/4; 
  size = 50;
  buttoncolor = color(153, 153, 153);
  highlight = color(255, 255, 255);
rect4 = new RectButton(x, y, size, buttoncolor, highlight);  

}
void draw() {

  stroke(255);
  update(mouseX, mouseY);
  rect1.display();
  rect2.display();
  rect3.display();
  rect4.display();


}
void update(int x, int y) {
  if(locked == false) {
    rect1.update();
    rect2.update();
    rect3.update();
    rect4.update();


  } 
  else {
    locked = false;
  }
//Select 
  if(mousePressed) {
    if(rect1.pressed()) {            //Red button
      myPort.write('1');
    } 
    else if(rect2.pressed()) {    //Green button
      myPort.write('2');
    }
    else if(rect3.pressed()) {    //Blue button
   
      myPort.write('3');
    }
    else if(rect4.pressed()) {    //White button
    
      myPort.write('4');
    }
    
    }
  }

class Button {
  int x, y;
  int size;
  color basecolor, highlightcolor;
  color currentcolor;
  boolean over = false;
  boolean pressed = false;   
  void update() 
  {
    if(over()) {
      currentcolor = highlightcolor;
    } 
    else {
      currentcolor = basecolor;
    }
  }
  boolean pressed() 
  {
    if(over) {
      locked = true;
      return true;
    } 
    else {
      locked = false;
      return false;
    }
  }
  boolean over() 
  { 
    return true;
  }
  void display() 
  {
  }
}
class RectButton extends Button {
  RectButton(int ix, int iy, int isize, color icolor, color ihighlight) 
  {
    x = ix;
    y = iy;
    size = isize;
    basecolor = icolor;
    highlightcolor = ihighlight;
    currentcolor = basecolor;
  }
  boolean over() 
  {
    if( overRect(x, y, size, size) ) {
      over = true;
      return true;
    } 
    else {
      over = false;
      return false;
    }
  }
  void display() 
  {
    stroke(255);
    fill(currentcolor);
    rect(x, y, size, size);
  }
}
boolean overRect(int x, int y, int width, int height) {
  if (mouseX >= x && mouseX <= x+width && 
    mouseY >= y && mouseY <= y+height) {
    return true;
  } 
  else {
    return false;
  }
}


void serialEvent (Serial myPort) {

  // get the ASCII string:
  String inString = myPort.readStringUntil('\n');
  if (inString != null) {
    inString = trim(inString);                // trim off whitespaces.
    float inByte = float(inString);           // convert to a number.
    inByte = map(inByte/2, 0, 1023/2,  0, height/2); //map to the screen height.
  // Sets 'a' to 27
    //Drawing a line from Last inByte to the new one.
 

    stroke(255,255,255);     //stroke color
    strokeWeight(1);        //stroke wider
    line(lastxPos, lastheight, xPos, height - inByte); 
    lastxPos= xPos;
    lastheight= int(height-inByte);

    // at the edge of the window, go back to the beginning:
    if (xPos >= width) {
      xPos = 0;
      lastxPos= 0;
      background(0);  //Clear the screen.
    } 
    else {
      // increment the horizontal position:
      xPos++;
    }
  }
}

